;;
;;                                                                       
;;  Ejemplo de inicializacin y uso del modo X.                          
;;                                                                       
;;  1996 Compiler SoftWare                                               
;;                                                                       
;;  Creado con Borland TASM 3.1 pero creo que funcionar con todos los de
;;  Borland a partir de la v2.0, y con otros Assemblers shareware median-
;;  te pequeas modificaciones de adaptacin a su sintaxis.              
;;                                                                       
;;  Ver COMPILER.NFO                                                     
;;                                                                       
;;;-)

        DOSSEG
        .286                                     ; SHL BX, 6  ; etc...
        .MODEL SMALL

        .STACK 200h

        .DATA                                 
                                                  
        .CODE

include modox.inc                                ; librera

Start:
        call Set_320x240X               

        mov bx, 255                     ; Xinicial = 255
        mov cx, 99                      ; Y = 99
bucle:                                  
        mov ah, bl                      ; COLOR = X           (255->0)
        call PutPixelX                  ; ponemos 255 puntos en una lnea 
        dec bx                          ; horizontal.
        jnz bucle

                                         ; prueba de GetPixelX ( = 0 )
        xor bx, bx                       ; coord. X  (0)
        xor cx, cx                       ; coord. Y  (0)
        call GetPixelX                   ; AL = GetPixelX( 0, 0 );

        xor ah, ah
        int 16h                          ; pausa
        
        mov ax, 3                        
        int 10h                          ; modo texto 80x25 x 16c

        mov ah, 4ch
        int 21h                          ; salir al dos.

END Start 
